Qt Cryptographic Architecture: QCA::CertificateAuthority Class Reference

# QCA::CertificateAuthority Class Reference
[QCA user API]

A Certificate Authority is used to generate Certificates and Certificate Revocation Lists (CRLs). More...

`#include <QtCrypto>`

Inheritance diagram for QCA::CertificateAuthority:

Collaboration diagram for QCA::CertificateAuthority:

[legend]

List of all members.

## Public Member Functions
Certificate | certificate () const
| CertificateAuthority (const CertificateAuthority &from)
| CertificateAuthority (const Certificate &cert, const PrivateKey &key, const QString &provider)
Certificate | createCertificate (const PublicKey &key, const CertificateOptions &opts) const
CRL | createCRL (const QDateTime &nextUpdate) const
CertificateAuthority & | operator= (const CertificateAuthority &from)
Certificate | signRequest (const CertificateRequest &req, const QDateTime &notValidAfter) const
CRL | updateCRL (const CRL &crl, const QList< CRLEntry > &entries, const QDateTime &nextUpdate) const

## Detailed Description

A Certificate Authority is used to generate Certificates and Certificate Revocation Lists (CRLs).

## Constructor & Destructor Documentation

QCA::CertificateAuthority::CertificateAuthority | ( | const Certificate & | cert,
|  | const PrivateKey & | key,
|  | const QString & | provider |
| ) |  |  |

Create a new Certificate Authority.

Parameters:

  | cert | the CA certificate
  | key | the private key associated with the CA certificate
  | provider | the provider to use, if a specific provider is required

QCA::CertificateAuthority::CertificateAuthority | ( | const CertificateAuthority & | from | ) |

Copy constructor.

Parameters:

  | from | the CertificateAuthority to copy from

## Member Function Documentation

Certificate QCA::CertificateAuthority::certificate | ( |  | ) | const

The Certificate belonging to the CertificateAuthority.

This is the Certificate that was passed as an argument to the constructor

Certificate QCA::CertificateAuthority::createCertificate | ( | const PublicKey & | key,
|  | const CertificateOptions & | opts |
| ) |  |  | const

Create a new Certificate.

Parameters:

  | key | the Public Key to use to create the Certificate
  | opts | the options to use for the new Certificate

CRL QCA::CertificateAuthority::createCRL | ( | const QDateTime & | nextUpdate | ) | const

Create a new Certificate Revocation List (CRL).

Parameters:

  | nextUpdate | the date that the CRL will be updated

Returns:
  an empty CRL

CertificateAuthority& QCA::CertificateAuthority::operator= | ( | const CertificateAuthority & | from | ) |

Standard assignment operator.

Parameters:

  | from | the CertificateAuthority to copy from

Certificate QCA::CertificateAuthority::signRequest | ( | const CertificateRequest & | req,
|  | const QDateTime & | notValidAfter |
| ) |  |  | const

Create a new Certificate by signing the provider CertificateRequest.

Parameters:

  | req | the CertificateRequest to sign
  | notValidAfter | the last date that the Certificate will be valid

CRL QCA::CertificateAuthority::updateCRL | ( | const CRL & | crl,
|  | const QList< CRLEntry > & | entries,
|  | const QDateTime & | nextUpdate |
| ) |  |  | const

Update the CRL to include new entries.

Parameters:

  | crl | the CRL to update
  | entries | the entries to add to the CRL
  | nextUpdate | the date that this CRL will be updated

Returns:
  the update CRL

The documentation for this class was generated from the following file:

- qca_cert.h